import itertools
import math

def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])

def minimal_tour(n, points):
    min_length = float('inf')
    
    for perm in itertools.permutations(points):
        length = 0
        for i in range(n - 1):
            length += calculate_distance(perm[i], perm[i + 1])
        min_length = min(min_length, length)
    
    return min_length

n = int(input().strip())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

result = minimal_tour(n, points)
print(f"{result:.6f}")