import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)

    def bfs(start_node, max_distance):
        queue = collections.deque([(start_node, 0)])
        visited = {start_node}
        reachable = set()
        while queue:
            node, dist = queue.popleft()
            reachable.add(node)
            if dist < max_distance:
                for neighbor in graph[node]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, dist + 1))
        return reachable

    protected_warehouses = set()
    for guard_warehouse, max_dist in guards:
        protected_warehouses.update(bfs(guard_warehouse, max_dist))

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*protected_warehouses)


solve()

