import collections

def solve():
    n, m, k = map(int, input().split())
    adj_matrix = [[0] * (n + 1) for _ in range(n + 1)]
    for _ in range(m):
        u, v = map(int, input().split())
        adj_matrix[u][v] = adj_matrix[v][u] = 1

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    def bfs(start_node, max_distance):
        queue = collections.deque([(start_node, 0)])
        visited = {start_node}
        reachable = set()
        while queue:
            node, dist = queue.popleft()
            reachable.add(node)
            if dist < max_distance:
                for neighbor in range(1, n + 1):
                    if adj_matrix[node][neighbor] == 1 and neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, dist + 1))
        return reachable

    protected_warehouses = set()
    for guard_warehouse, max_dist in guards:
        protected_warehouses.update(bfs(guard_warehouse, max_dist))

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*protected_warehouses)

solve()

