import collections

def solve():
    n, m, k = map(int, input().split())
    edges = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        edges[u].append(v)
        edges[v].append(u)

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    def bfs(start, max_dist):
        q = collections.deque([(start, 0)])
        visited = {start}
        reachable = {start}
        while q:
            curr, dist = q.popleft()
            if dist < max_dist:
                for neighbor in edges[curr]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        q.append((neighbor, dist + 1))
                        reachable.add(neighbor)
        return reachable

    protected = set()
    for guard_pos, guard_range in guards:
        protected.update(bfs(guard_pos, guard_range))

    result = sorted(list(protected))
    print(len(result))
    if result:
        print(*result)

solve()

