import collections

def solve():
    n, m, k = map(int, input().split())
    graph = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        graph[u].append(v)
        graph[v].append(u)

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    def dfs(node, max_dist, visited, current_dist):
      visited.add(node)
      reachable = {node}
      if current_dist < max_dist:
        for neighbor in graph[node]:
          if neighbor not in visited:
            reachable.update(dfs(neighbor, max_dist, set(visited), current_dist + 1))
      return reachable


    protected = set()
    for guard_pos, guard_range in guards:
        protected.update(dfs(guard_pos, guard_range, set(), 0))

    result = sorted(list(protected))
    print(len(result))
    if result:
        print(*result)

solve()

